'use strict';

var _ = require('lodash');

//var builtInTypes = [Object, Function, Array, String, Boolean, Number, Date, RegExp, Error];

var typeIs = function(object) {
	var type = " ";
	if (_.isObject(object)) {
		if (_.isArray(object)) {
			type = "array";
		} else if (_.isDate(object)) {
			type = "date";
		} else {
			type = "object";
		}
	} else if (_.isFunction(object)) {
		type = "function";
	} else if (_.isString(object)) {
		type = "string";
		if (Date.parse(object) && isNaN(object)) {
			type = "date";
		}
	} else if (_.isBoolean(object)) {
		type = "boolean";
	} else if (_.isNumber(object)) {
		type = "number";
	} else if (_.isRegExp(object)) {
		type = 'regExp';
	} else if (_.isError(object)) {
		type = 'error';
	}
	return type;
};


exports.typeIs = typeIs;